<?php
/**
 * @project    : yabandpay
 * @description:
 * @user       : PersiLiao
 * @email      : persi@sixsir.com
 * @date       : 2018/12/2
 * @time       : 23:45
 */

namespace YaBandPay\PersiLiao;


class Notify
{
    /**
     * @var Cryptography
     */
    private $cryptography;

    public function __construct(Cryptography $cryptography)
    {
        $this->cryptography = $cryptography;
    }

    protected function input()
    {
        $result = \file_get_contents('php://input');
        if(!empty($result)){
            $result = \urldecode($result);
        }else{
            throw new \InvalidArgumentException('notify data is empty');
        }
        $result = \json_decode($result, true);
        if(\json_last_error()){
            throw new \InvalidArgumentException('notify data is error, ' . \json_last_error_msg());
        }
        if(!isset($result['sign']) || empty($result['sign']) || !isset($result['data']) || empty($result['data'])){
            throw new \InvalidArgumentException('notify data is field error');
        }
        return $result;
    }

    public function getOrderInfo()
    {
        $data = $this->input();
        if($this->cryptography->verify($data) === false){
            throw new \InvalidArgumentException('notify data signature verification failed');
        }
        $data['data']['demo'] = json_decode($data['data']['demo'], true);
        return $data['data'];
    }

    /**
     * @return Cryptography
     */
    public function getCryptography()
    {
        return $this->cryptography;
    }

    /**
     * @param Cryptography $cryptography
     */
    public function setCryptography(Cryptography $cryptography)
    {
        $this->cryptography = $cryptography;
    }
}